-- Handle MonitorsPlus' random monitors
function A_RecyclePowers(actor, var1, var2)
	return true
end

local MP_toggledTV = {}
for i = 1, #MP_monitorsConstants
	MP_toggledTV[_G[MP_monitorsConstants[i]]] = true
end

rawset(_G, "MP_toggleMonitor", function(monitor)
	MP_toggledTV[monitor] = not MP_toggledTV[monitor]
end)

rawset(_G, "MP_isTVtoggled", function(monitor)
	return MP_toggledTV[monitor]
end)

local mrespawn = {}	-- monitors respawn table
local RSTIMER = TICRATE*30
addHook("NetVars", function(net)
	mrespawn = net(mrespawn)
	MP_toggledTV = net(MP_toggledTV)
end)

addHook("MapLoad", do
	mrespawn = {}
end)

-- handle monitor respawning
rawset(_G, "MP_RespawnThink", function()
	if not #mrespawn return end
	for k,v in ipairs(mrespawn) do
		if v and v.xyz
			if v.time
				v.time = $-1
				continue
			else
				-- time's up, spawn a new monitor
				local tv = P_SpawnMobj(v.xyz[1], v.xyz[2], v.xyz[3], MT_MYSTERY_BOX)
				tv.flags2 = v.flags
				table.remove(mrespawn, k)
				continue
			end
		end
	end
end)

-- fancyTV
rawset(_G, "fancyTV", function(mo, item, p, gbag, item2)
	local s_item = item
	item = mo and mobjinfo[mo].damage or $
	if not item return end
	local sstate = states[mobjinfo[item].spawnstate]
	local sprite = string.format("%s%c0", sprnames[sstate.sprite], string.byte('A')+sstate.frame)

	if not p return end
	if not p.monitor_list
		p.monitor_list = {}
	end
	if #p.monitor_list > 8
		table.remove(p.monitor_list, 1)
	end
	table.insert(p.monitor_list, {x = 0, spr = sprite, grabbag = gbag, info=item2})
	p.monitor_time = TICRATE*5/2
end)

-- setting up:
	-- {mt_constant, strong monitor odds, weak monitor odds, random monitor odds}

local monitorOdds = {
	-- Vanilla
	{MT_RING_BOX,			0, 20, 40},
	{MT_PITY_BOX, 			0, 0, 0},
	{MT_ATTRACT_BOX,		25, 6, 10},
	{MT_FORCE_BOX, 			25, 6, 10},
	{MT_ARMAGEDDON_BOX, 	30, 2, 10},
	{MT_WHIRLWIND_BOX, 		20, 40, 10},
	{MT_ELEMENTAL_BOX, 		10, 40, 10},
	{MT_SNEAKERS_BOX, 		0, 50, 10},
	{MT_INVULN_BOX, 		20, 0, 5},
	{MT_1UP_BOX, 			10, 5, 5},
	{MT_EGGMAN_BOX,			0, 0, 5},
	{MT_MIXUP_BOX, 			5, 5, 5},
	{MT_GRAVITY_BOX, 		0, 0, 4},
	{MT_RECYCLER_BOX, 		0, 0, 0},
	{MT_SCORE1K_BOX, 		0, 0, 0},
	{MT_SCORE10K_BOX, 		0, 0, 0},
	{MT_FLAMEAURA_BOX, 		20, 10, 15},
	{MT_THUNDERCOIN_BOX, 	20, 10, 15},
	{MT_BUBBLEWRAP_BOX, 	20, 10, 15},

	-- v1.x
	{MT_HYPERMONITOR, 		1, 0, 2},
	{MT_CACTISHIELDMONITOR, 25, 20, 10},
	{MT_ENDMONITOR, 		1, 1, 1},
	{MT_RANDOMMONITOR, 		15, 10, 8},
	{MT_SILVERRINGBOXMONITOR, 0, 25, 10},
	{MT_EARTHMONITOR, 		15, 5, 15},
	{MT_LOSEMONITOR, 		0, 5, 2},
	{MT_SUPPLYMONITOR, 		15, 2, 10},
	{MT_INVISMONITOR, 		15, 15, 15},
	{MT_POISONMONITOR, 		20, 25, 15},
	{MT_ESPMONITOR, 		20, 10, 15},
	{MT_JUMPMONITOR, 		0, 20, 20},
	{MT_ICEMONITOR, 		15, 5, 15},
	{MT_SUPERMONITOR, 		2, 0, 3},
	{MT_COMBINERINGMONITOR,	0, 20, 10},
	{MT_HYPERRINGMONITOR, 	5, 20, 15},
	{MT_RESETMONITOR, 		2, 2, 1},
	{MT_FIREMONITOR, 		20, 15, 20},
	{MT_BEANMONITOR, 		2, 0, 1},
	{MT_PLATINUMMONITOR, 	20, 0, 10},
	
	-- v2.x
	{MT_THUNDERMONITOR,		25, 10, 15},
	{MT_BUMPERMONITOR, 		25, 20, 15},
	{MT_PIZZAMONITOR, 		15, 5, 5},
	{MT_EXPLOSIONMONITOR, 	10, 0, 4},
	{MT_TITANIUMMONITOR, 	20, 5, 12},
	{MT_WEEBMONITOR, 		20, 3, 12},
	{MT_DIGMONITOR, 		15, 7, 10},
	{MT_FOFMONITOR, 		6, 2, 5},
	{MT_PANCAKEMONITOR, 	10, 0, 4},
	{MT_EXPANDMONITOR, 		10, 0, 4},
	{MT_SENTRYMONITOR,		0, 4, 8},
	{MT_GOOPMONITOR, 		15, 0, 10},
	{MT_TURBOMONITOR, 		30, 0, 13},
	{MT_MEGIDOLAONMONITOR, 	3, 0, 1},
	{MT_HEAVYGRAVMONITOR, 	4, 3, 3},
	{MT_LOWGRAVMONITOR, 	5, 3, 6},
	{MT_BATKANMONITOR, 		4, 1, 3},
	{MT_FITNESSMONITOR, 	10, 2, 4},
	{MT_BLOOPERMONITOR, 	0, 20, 20},
	{MT_REGENMONITOR, 		15, 10, 15},
	{MT_BSHELLMONITOR, 		15, 10, 10},
	{MT_HYPERSHOESMONITOR, 	15, 10, 15},
	{MT_JDRIVEMONITOR, 		5, 0, 2},
	
	-- v3.x
	{MT_INSTAMONITOR, 		2, 4, 5},
	{MT_ANTIMATTERMONITOR, 	25, 15, 8},
	{MT_SHRINKMONITOR, 		15, 5, 5},
	{MT_MUSHMONITOR, 		15, 5, 8},
	{MT_FIBERLOSTMONITOR,	0, 3, 3},
	{MT_DARKHOURMONITOR, 	5, 5, 4},
	{MT_VIKKMONITOR,		4, 2, 3},
}

addHook("NetVars", function(net)
	monitorOdds = net(monitorOdds)
end)

-- copy odds...
local odds_cpy = {}
for i = 1, #monitorOdds
	odds_cpy[i] = {monitorOdds[i][1], monitorOdds[i][2], monitorOdds[i][3], monitorOdds[i][4]} 
end

rawset(_G, "MP_getMonitorOdds", function()
	return monitorOdds
end)

rawset(_G, "MP_setOddsZero", function()
	for i = 1, #odds_zero
		monitorOdds[i] = {odds_zero[i][1], odds_zero[i][2], odds_zero[i][3], odds_zero[i][4]}
	end
end)

rawset(_G, "MP_resetOdds", function()
	for i = 1, #odds_cpy
		monitorOdds[i] = {odds_cpy[i][1], odds_cpy[i][2], odds_cpy[i][3], odds_cpy[i][4]}
	end
end)

-- some monitors shouldnt be obtained outside of ringslinger
-- ...without some hackery, of course
-- Can't be pulled in platform gametypes
local singleplayerWhitelist = {
	-- vanilla
	MT_GRAVITY_BOX,
	-- v1.x
	--MT_SUPERMONITOR, MT_HYPERMONITOR, -- super doesnt work, period
	--MT_SHRINKMONITOR, MT_MUSHMONITOR,	-- these'll interfere with checkpoints (3.x: fixed)
	-- v2.x
	MT_FOFMONITOR, MT_PANCAKEMONITOR, MT_EXPANDMONITOR,	MT_GOOPMONITOR, -- all of these interfere horribly with stages, sometimes making them not completable
	MT_JDRIVEMONITOR,	-- detrimental in SP
}

-- can't be pulled if not G_RingSlingerGametype
local ringSlingerWhiteList = {
	MT_SUPPLYMONITOR, MT_FIREMONITOR, MT_MEGIDOLAONMONITOR,	-- useless
}

-- oddsIndex:
/*
	2: strong box
	3: weak box
	4: random box
	-1: grabbag
*/
rawset(_G, "MP_getMonitorFromOdds", function(oddsIndex)
	local monitor = MT_PLEBMONITOR	-- always start with this
	
	local modds = MP_getMonitorOdds()
	
	local spawnchance, totalspawnchance = {}, 0
	for i = 1, #modds
		local odds = modds[i][oddsIndex]
		
		-- check for nil specifically.
		-- this is used by grabbag
		if odds == nil
			
			-- however, make SURE the monitor is enabled AT ALL
			if modds[i][2] == 0 and modds[i][3] == 0 and modds[i][4] == 0	-- bro thinks he part of the team
			or modds[i][1] == MT_ENDMONITOR	-- this one is just annoying.
			or modds[i][1] == MT_MEGIDOLAONMONITOR -- this too!
				odds = 0
			else
				odds = 1
			end
		end
		
		-- some monitors arent available in platform gamemodes:
		if (gametyperules & (GTR_FRIENDLY|GTR_LIVES|GTR_SPAWNENEMIES))
			for j = 1, #singleplayerWhitelist
				local checkMonitor = modds[i][1]
				local illegalMonitor = singleplayerWhitelist[j]
				if (checkMonitor != illegalMonitor) then continue end
				
				-- if we're here, remove their odds
				odds = 0
				break
			end
		end

		-- some monitors arent available outside of ringslinger:
		if not (gametyperules & GTR_RINGSLINGER)
			for j = 1, #ringSlingerWhiteList
				local checkMonitor = modds[i][1]
				local illegalMonitor = ringSlingerWhiteList[j]
				if (checkMonitor != illegalMonitor) then continue end
				
				-- if we're here, remove their odds
				odds = 0
				break
			end
		end
		
		totalspawnchance = $+odds
		spawnchance[i] = totalspawnchance
	end
	
	local monitor = MT_PLEBMONITOR
	if (totalspawnchance > 0)
		-- chance totalspawnchance
		totalspawnchance = P_RandomKey($)
		
		for i = 1, #modds
			monitor = modds[i][1]
			if (spawnchance[i] > totalspawnchance)
				break
			end
		end
	end
	
	return monitor
end)

-- setup monitor respawn odds and fuse
local function MP_monitorFuse(mo)
	if not (mo and mo.valid) then return end
	--if not ((mo.flags2 & MF2_AMBUSH) or (mo.flags2 & MF2_STRONGBOX)) return false end
	
	if gametyperules & GTR_FRIENDLY and not cv_coopmonitors.value return end
	
	if not (gametyperules & GTR_FRIENDLY) and not (mo.flags & MF2_AMBUSH|MF2_STRONGBOX) return false end
	
	local oddsIndex = (mo.flags2 & MF2_STRONGBOX) and 2 or 3	-- MF2_STRONGBOX: use strong odds (2), otherwise weak (3)
	local monitor = MP_getMonitorFromOdds(oddsIndex)
	
	local newmo = P_SpawnMobjFromMobj(mo, 0, 0, 0, monitor)
	newmo.flags2 = mo.flags2
	newmo.mplus_randomtv = true
	P_RemoveMobj(mo)
	return true
end

local function MP_monitorFuse(mo)
	if not (mo and mo.valid) then return end
	--if not ((mo.flags2 & MF2_AMBUSH) or (mo.flags2 & MF2_STRONGBOX)) return false end

	local monitor = mo.type	-- keep the same monitor
	if (mo.flags2 & (MF2_AMBUSH|MF2_STRONGBOX))	-- unless WRM/SRM
		local oddsIndex = (mo.flags2 & MF2_STRONGBOX) and 2 or 3	-- MF2_STRONGBOX: use strong odds (2), otherwise weak (3)
		monitor = MP_getMonitorFromOdds(oddsIndex)
	end
	
	local newmo = P_SpawnMobjFromMobj(mo, 0, 0, 0, monitor)
	newmo.flags2 = mo.flags2
	P_RemoveMobj(mo)
	return true
end

for k, v in ipairs(MP_getMonitorOdds())
	-- add fuse hooks for each monitor
	addHook("MobjFuse", MP_monitorFuse, v[1])
	
	-- fancyTV
	addHook("MobjDeath", function(mo, inflictor, source)
		fancyTV(mo.type, nil, (inflictor and inflictor.player) and inflictor.player or source.player)
	end, v[1])
end

-- fuse away all monitors on mapload :XD:
addHook("MapLoad", do
	for m in mobjs.iterate()
		if m and m.valid and m.flags & MF_MONITOR
			m.fuse = 1
		end
	end
end)

local function canGetWpnRing(mo)
	--if not MP_franticWeapons() return end
	if not cv_monitorweapons.value return end
	if not mo.player return end
	if not G_RingSlingerGametype() return end
	if G_TagGametype() and not (mo.player.pflags & PF_TAGIT) return end
	return true
end

local wpnringmonitors = {
	MT_INFINITYMONITOR,
	MT_AUTOMATICMONITOR,
	MT_BOUNCEMONITOR,
	MT_BOMBMONITOR,
	MT_GRENADEMONITOR,
	MT_SCATTERMONITOR,
	MT_RAILMONITOR
}

addHook("MobjDeath", function(mo, inflictor, source)

	mo.health = 0
	mo.flags = ($|MF_NOCLIP) & (~MF_SOLID)

	local explode = mobjinfo[mo.info.speed].mass
	local wantedz = mo.z + mo.height/4
	if (mo.eflags & MFE_VERTICALFLIP)
		wantedz = mo.z + 3*(mo.height/4) - FixedMul(mobjinfo[explode].height, mo.scale)
	end
	local remains = P_SpawnMobj(mo.x, mo.y, wantedz, explode)
	if (mo.eflags & MFE_VERTICALFLIP)
		remains.eflags = $|MFE_VERTICALFLIP
		remains.flags2 = $|MF2_OBJECTFLIP
	end

	remains = P_SpawnMobj(mo.x, mo.y, wantedz, mo.info.speed)
	remains.type = mo.type
	remains.destscale = mo.destscale
	P_SetScale(remains, mo.scale)
	remains.flags = mo.flags
	remains.flags2 = mo.flags2
	
	remains.threshold = 68
	S_StartSound(remains, mo.info.deathsound)
	remains.flags2 = $ & ~MF2_AMBUSH
	
	-- respawning
	if (CV_FindVar("respawnitem").value and gametype != GT_COOP and (modifiedgame or netgame or multiplayer))	-- ripped right from source
		remains.fuse = CV_FindVar("respawnitemtime").value*TICRATE	--cv_mprit.value*TICRATE

		-- add to respawn table:
		mrespawn[#mrespawn+1] = {
			xyz = {mo.x, mo.y, mo.z},	-- coords
			time =  CV_FindVar("respawnitemtime").value*TICRATE,	-- respawn time
			flags = mo.flags2,			-- used for reverse gravity
		}
	end

	local pmo = inflictor and inflictor.type == MT_PLAYER and inflictor or source and source.type == MT_PLAYER and source or nil
	if not pmo return end
	
	pmo.player.numboxes = $+1	-- competition
	
	-- check for karma
	--if MP_rollKarma(pmo.player) return true end
	-- else pop a random monitor:
	local monitor = MP_getMonitorFromOdds(4)	-- 4 is for random odds!
	local newpanel = mobjinfo[monitor].damage
	--print(monitor.."->"..newpanel)
	local newmobj
	-- bean monitor hardcode:
	if monitor == MT_BEANMONITOR
		mrespawn[#mrespawn] = nil
	end
	if (mo.eflags & MFE_VERTICALFLIP)
		newmobj = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height - FixedMul(13*FRACUNIT + mobjinfo[item].height, mo.scale), newpanel)
		newmobj.eflags = $|MFE_VERTICALFLIP
	else
		newmobj = P_SpawnMobj(mo.x, mo.y, mo.z + FixedMul(13*FRACUNIT, mo.scale), newpanel)
	end

	newmobj.destscale = mo.destscale
	P_SetScale(newmobj, mo.scale)
	newmobj.target = pmo
	--incrementKarma(pmo.player, monitor)
	--pmo.player.MP_karmaData.monitortime = $+TICRATE*15
	fancyTV(nil, newmobj.type, pmo.player, nil, monitor)

	-- should we get a weapon ring alongside that?
	if canGetWpnRing(inflictor) and not P_RandomRange(0, 2)
		local testlist = {}
		for k,v in ipairs(wpnringmonitors)
			if MP_toggledTV[v]
				testlist[#testlist+1] = v
			end
		end
		monitor = testlist[P_RandomRange(1, #testlist)]
		if not monitor return end	-- no weapon rings????????
		newpanel = mobjinfo[monitor].damage
		newmobj = P_SpawnMobj(mo.x, mo.y, mo.z, newpanel)
		newmobj.target = pmo
		newmobj.flags2 = $|MF2_DONTDRAW
		fancyTV(nil, newmobj.type, pmo.player)
	end

	local fakebox = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
	fakebox.state = S_BOX_POP1
	S_StartSound(fakebox, sfx_pop)
	fakebox.eflags = mo.eflags & MFE_VERTICALFLIP
	if (CV_FindVar("respawnitem").value and gametype != GT_COOP and (modifiedgame or netgame or multiplayer))
		fakebox.fuse = CV_FindVar("respawnitemtime").value*TICRATE
	end

	P_RemoveMobj(mo)
	return true
end, MT_MYSTERY_BOX)


local function mplus_monitor_replace(actor)
	if not cv_legacymonitors.value return end
	if not (gametyperules & GTR_FRIENDLY) return end
	if leveltime > 5 return end
	
	if actor.flags2 & MF2_AMBUSH|MF2_STRONGBOX
		
		local strong = false
		
		if actor.spawnpoint and actor.spawnpoint.valid
			strong = actor.spawnpoint.options & 8 -- MTF_AMBUSH
		elseif actor.flags & MF2_STRONGBOX
			strong = true
		end
		
		local index = strong and 2 or 3
		
		local newtv = MP_getMonitorFromOdds(index)
		
		actor.mplus_randomtv = true
		actor.type = newtv
		actor.state = mobjinfo[newtv].spawnstate
		if strong
			actor.flags2 = $|MF2_STRONGBOX
		end
	end
end

addHook("MobjSpawn", mplus_monitor_replace, MT_RING_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_PITY_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_ATTRACT_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_FORCE_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_ARMAGEDDON_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_WHIRLWIND_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_ELEMENTAL_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_SNEAKERS_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_INVULN_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_1UP_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_EGGMAN_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_GRAVITY_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_RECYCLER_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_SCORE1K_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_SCORE10K_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_FLAMEAURA_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_THUNDERCOIN_BOX)
addHook("MobjSpawn", mplus_monitor_replace, MT_BUBBLEWRAP_BOX)

-- build tv mobjinfo blah blah
local mthingnum = 430
local calls = 0

-- MP: buildMonitor:
-- builds Monitor with specified args. MapThingNum and such automatically accounted for!
-- spr1 = srp2 in most cases

rawset(_G, "MP_buildMonitor", function(type, icontype, tvstate, iconstate, spr1, spr2, action)

mobjinfo[type] = {
	doomednum = mthingnum+calls,
    spawnstate = tvstate,
    spawnhealth = 1,
    seestate = S_NULL,
    seesound = sfx_None,
    reactiontime = 8,
    attacksound = sfx_None,
    painstate = S_BOX_POP1,
    painchance = 0,
    painsound = sfx_None,
    meleestate = S_NULL,
    missilestate = S_NULL,
    deathstate = S_BOX_POP1,
    xdeathstate = S_NULL,
    deathsound = sfx_pop,
    speed = 1,
    radius = 16*FRACUNIT,
    height = 48*FRACUNIT,
    dispoffset = 0,
    mass = 100,
    damage = icontype,
    activesound = sfx_None,
    flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR,
    raisestate = MT_THOK
}

-- monitor icon object
mobjinfo[icontype] = {
	doomednum = -1,
    spawnstate = iconstate,
    spawnhealth = 1,
    seestate = S_NULL,
    seesound = sfx_shield,
    reactiontime = 8,
    attacksound = sfx_None,
    painchance = 0,
    painsound = sfx_None,
    meleestate = S_NULL,
    missilestate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_pop,
    speed = 2*FRACUNIT,
    radius = 8*FRACUNIT,
    height = 14*FRACUNIT,
    dispoffset = 0,
    mass = 100,
    damage = 62*FRACUNIT,
    activesound = sfx_None,
    flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_BOXICON,
    raisestate = MT_THOK
}

states[tvstate] = {spr1, A, 2, nil, 0, 0, tvstate+1}
states[tvstate+1] = {SPR_MSTV, A, 1, nil, 0, 0, tvstate}
states[tvstate+2] = {spr1, B, 1, nil, 0, 0, S_NULL}

states[iconstate] = {spr1, B, 4, nil, 0, 0, iconstate+1}
states[iconstate+1] = {spr2, C, 4, nil, 0, 0, iconstate+2}
states[iconstate+2] = {spr2, D, 4, nil, 0, 0, iconstate+3}
states[iconstate+3] = {spr2, E, 4, nil, 0, 0, iconstate+4}
states[iconstate+4] = {spr1, B, 18, action, 0, 0, S_NULL}

calls = $+1

end)
