function A_ShrinkStuff(actor)
    local p = actor.target.player
    local GoS = P_RandomRange(0, 9)
	local trololol = P_RandomRange(0, 29)

    local lightning = {}

	if trololol == 0
		if not p.mo.MP_effects[ef_shrink]
			S_StartSound(nil, _G["sfx_litng"..P_RandomRange(1, 4)])
			P_FlashPal(p, 1, 3)
			MP_giveEffect(p, ef_shrink)
		end
	else
		for sonc in players.iterate
			if GoS == 0
				if not sonc.spectator and (sonc.mo and sonc.mo.health) and sonc ~= p
				and not sonc.powers[pw_super] and not sonc.powers[pw_invulnerability]
				and not sonc.mo.MP_effects[ef_grow]
					table.insert(lightning, sonc.mo)
				end
			else
				if not sonc.spectator and (sonc.mo and sonc.mo.health) and sonc ~= p
				and not sonc.powers[pw_super] and not sonc.powers[pw_invulnerability]
				and not sonc.mo.MP_effects[ef_shrink]
					table.insert(lightning, sonc.mo)
				end
			end
        end
    end

    if #lightning
        S_StartSound(nil, _G["sfx_litng"..P_RandomRange(1, 4)])
        for k, v in ipairs(lightning)
            P_FlashPal(v.player, 1, 3)
			MP_giveEffect(v.player, GoS and ef_shrink or ef_grow)
        end
    end
end

local shrink_data = {
	time = 15*TICRATE,
	func = function(mo)
				mo.scale = FRACUNIT/3

				if (leveltime%5 == 0) and not mo.player.powers[pw_super]
					mo.colorized = true
					mo.color = SKINCOLOR_SUPERGOLD5
				else
					mo.colorized = false
					if not mo.player.powers[pw_super]
						mo.color = mo.player.skincolor
					end	
				end
				
				-- fix checkpoints
				if (mo.oldstarpostnum != nil)
				and (mo.player.starpostnum != mo.oldstarpostnum)
					mo.player.starpostscale = FRACUNIT
				end
				mo.oldstarpostnum = mo.player.starpostnum
			end,
	get = function(mo)
					S_StartSound(mo, sfx_kc59)
					if mo.MP_effects[ef_grow]
						MP_loseEffect(mo.player, ef_grow)
					end
					mo.oldstarpostnum = nil
				end,
	lose = function(mo)
					if not mo.MP_effects[ef_grow]
						S_StartSound(mo, sfx_kc5a)
						mo.scale = FRACUNIT
					end
					mo.color = mo.player.skincolor
					mo.colorized = false
					mo.oldstarpostnum = nil
				end,
	hudico = "SHMTICO",
}

local grow_data = {
	time = 20*TICRATE,
	func = function(mo)
					mo.scale = FRACUNIT*2+(FRACUNIT/2)
					mo.player.normalspeed = FixedMul(FRACUNIT*20/36, skins[mo.skin].normalspeed)

					if (leveltime%5 == 0) and not mo.player.powers[pw_super]
						mo.colorized = true
						mo.color = SKINCOLOR_SAPPHIRE
					else
						mo.colorized = false
						if not mo.player.powers[pw_super]
							mo.color = mo.player.skincolor
						end	
					end
					
					-- fix checkpoints
					if (mo.oldstarpostnum != nil)
					and (mo.player.starpostnum != mo.oldstarpostnum)
						mo.player.starpostscale = FRACUNIT
					end
					mo.oldstarpostnum = mo.player.starpostnum
				end,
	get = function(mo)
					S_StartSound(mo, sfx_kc5a)
					if mo.MP_effects[ef_shrink]
						MP_loseEffect(mo.player, ef_shrink)
					end
					mo.oldstarpostnum = nil
				end,
	lose = function(mo)
					if not mo.MP_effects[ef_shrink]
						S_StartSound(mo, sfx_kc59)
						mo.scale = FRACUNIT
						mo.player.normalspeed = skins[mo.skin].normalspeed
					end
					mo.color = mo.player.skincolor
					mo.colorized = false
					mo.oldstarpostnum = nil
				end,
	hudico = "MUMTICO",
}

effectList[ef_shrink] = shrink_data
effectList[ef_grow] = grow_data


addHook("ShouldDamage", function(mo, inflictor, source)
	
	if mo and mo.MP_effects and mo.MP_effects[ef_grow] and not mo.player.powers[pw_flashing]
	
		if inflictor and inflictor.valid 
		or source and source.valid
			
			S_StartSound(mo, sfx_rail2)
			local crit = P_SpawnMobj(mo.x, mo.y, mo.z+mo.scale*25, MT_THOK)
			crit.state = S_BLOCKED1
			crit.scale = mo.scale*3/2
			
			P_DoPlayerPain(mo.player, source, inflictor)
			mo.momx = $/2
			mo.momy = $/2
			mo.momz = $/2
			
			mo.MP_effects[ef_grow] = min(TICRATE*20 -1, $+TICRATE*2)
			
			if mo and mo.player
				mo.player.powers[pw_flashing] = TICRATE*3 -1
			end
			
			return false
		end
	end
end, MT_PLAYER)

states[S_ZIO1] = {SPR_EZIO, A, 2, nil, 0, 0, S_ZIO2}
states[S_ZIO2] = {SPR_EZIO, A|TR_TRANS30, 2, nil, 0, 0, S_ZIO3}
states[S_ZIO3] = {SPR_EZIO, A|TR_TRANS50, 2, nil, 0, 0, S_ZIO4}
states[S_ZIO4] = {SPR_EZIO, A|TR_TRANS70, 2, nil, 0, 0, S_NULL}

states[S_ZIO21] = {SPR_EZIO, B, 2, nil, 0, 0, S_ZIO22}
states[S_ZIO22] = {SPR_EZIO, B|TR_TRANS30, 2, nil, 0, 0, S_ZIO23}
states[S_ZIO23] = {SPR_EZIO, B|TR_TRANS50, 2, nil, 0, 0, S_ZIO24}
states[S_ZIO24] = {SPR_EZIO, B|TR_TRANS70, 2, nil, 0, 0, S_NULL}

MP_buildMonitor(MT_SHRINKMONITOR, MT_SHRINKICON, S_SHRITV, S_SHRIPOP1, SPR_SHMT, SPR_SHMT, A_ShrinkStuff)