-- the global effect that'll randomly tag players
function A_Vikk(actor)
	MP_addGlobalEffect(gef_vikk)
end

local gef_vikk_dta = {
	timer = 30*TICRATE,
	func = function(time)
		for p in players.iterate
			-- check if they're already vikk'd
			local mo = p.mo
			if (mo and mo.valid and mo.MP_effects)
			and (mo.MP_effects[ef_vikk])
				continue
			end
			
			-- cooldown so we don't get spammed with it
			p.mp_vikkcooldown = $ and $-1
			if (p.mp_vikkcooldown) then continue end
			
			-- try to roll for the vikk overlay
			local chance = FRACUNIT/128	-- this chance is rolled every tic, make sure it's low
			if not (P_RandomChance(chance)) then continue end
			
			-- if we're here, overlay them!
			MP_giveEffect(p, ef_vikk)
			p.mp_vikkcooldown = 3*TICRATE	-- cooldown so they don't get rarely spammed
		end
	end,
}
geffectList[gef_vikk] = gef_vikk_dta

-- the effect that player's get tagged with
local ef_vikk_data = {
	get = function(mo)
		S_StartSound(nil, sfx_vikk, mo.player)
	end,
	time = 28,
	func = function(mo)
		if not (leveltime%4)
			local drip = MP_spawnParticles(mo, MT_VIKKPARTICLE, nil, mo.y+P_RandomRange(-25, 25)*mo.scale)
			if drip
				drip.momz = (P_MobjFlip(drip) and -3 or 3)*drip.scale
				drip.destscale = 1
				drip.fuse = 21
			end
		end
	end,
	hudfunc = function(v, p, c, t)
		local viks = "VIKK"..(((t/3) % 7) +1)
		drawScreenwidePatch(v, v.cachePatch(viks))
	end,
}
effectList[ef_vikk] = ef_vikk_data

MP_buildMonitor(MT_VIKKMONITOR, MT_VIKKICON, S_VIKKTV, S_VIKKPOP1, SPR_VIMT, SPR_VIMT, A_Vikk)

states[S_VIKKPART1] = {SPR_VIPT, A, 2, nil, 0, 0, S_VIKKPART2}
states[S_VIKKPART2] = {SPR_VIPT, TR_TRANS30|A, 2, nil, 0, 0, S_VIKKPART3}
states[S_VIKKPART3] = {SPR_VIPT, TR_TRANS60|A, 2, nil, 0, 0, S_VIKKPART4}
states[S_VIKKPART4] = {SPR_VIPT, TR_TRANS90|A, 2, nil, 0, 0, S_NULL}

mobjinfo[MT_VIKKPARTICLE] = {
	doomednum = -1,
    spawnstate = S_VIKKPART1,
    spawnhealth = 1,
    seestate = S_NULL,
    seesound = sfx_None,
    reactiontime = 8,
    attacksound = sfx_None,
    painstate = S_NULL,
    painchance = 1,
    painsound = sfx_None,
    meleestate = S_NULL,
    missilestate = S_NULL,
    deathstate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_None,
    speed = 1*FRACUNIT,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    dispoffset = 1,
    mass = 16,
    damage = 1*FRACUNIT,
    activesound = sfx_None,
    flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY|MF_NOCLIPHEIGHT,
    raisestate = MT_THOK
}